#!/usr/bin/env python3

import asyncio
import datetime
import json
import logging
import io, os, sys
import pcpp
import time
import yaml
import websockets

START = time.time()
def time_from_start():
  return int((time.time() - START) * 1000) / 1000
def utc():
  return int(time.time() * 1000) / 1000

def yamlpp_load(path):
  with open(path, 'r') as f:
    data = f.read()     # original input
  p = pcpp.Preprocessor()
  p.parse(data)
  f = io.StringIO()
  p.write(f)
  data_ = f.getvalue()    # preprocessed input
  return yaml.load(data_, Loader=yaml.Loader)

def ready(name):
    return json.dumps({
      "message"   : "ready",
      "challenge" : "773bc1c2cf2df900a2d4f60c58b5ddb7",
      "type"      : name,
      "name"      : name,
      "version"   : "2024-11-21",
      "time"      : time_from_start(),
      "utc"       : utc(),
    })

def main(server, name):

  conf = yamlpp_load(sys.argv[1])

  with open(conf['log_filename'], 'w+') as log:
    log.write("# lte{} mock version 2024-11-21 (x86-64)\n".format(name))
    log.write("# Started on {}\n".format(
      datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")))

  if 'com_addr' in conf:
    ip, port = conf['com_addr'].split(':')
    asyncio.run(server(ip, port))
  while True:
    time.sleep(1)

if __name__ == "__main__":
  main()
