#!/usr/bin/env python3

import asyncio
import websockets
from ltemock import common

async def echo(websocket):
  try:
    await websocket.send(common.ready("UE"))
    async for message in websocket:
      pass
  except (asyncio.exceptions.IncompleteReadError, asyncio.exceptions.CancelledError, websockets.exceptions.ConnectionClosedError) as e:
    pass

async def server(ip, port):
    async with websockets.serve(echo, ip, port):
        await asyncio.get_running_loop().create_future()  # run forever

def main():

  common.main(server, "ue")

if __name__ == "__main__":
  main()
